'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeViewLabel = function (_Component) {
  _inherits(TreeViewLabel, _Component);

  function TreeViewLabel() {
    _classCallCheck(this, TreeViewLabel);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(TreeViewLabel).apply(this, arguments));
  }

  _createClass(TreeViewLabel, [{
    key: 'render',
    value: function render() {
      var styles = require('./../styles/TreeView.scss');
      var _props = this.props;
      var checked = _props.checked;
      var childCount = _props.childCount;
      var hasChildren = _props.hasChildren;
      var handleNodeCheckBoxClick = _props.handleNodeCheckBoxClick;
      var handleNodeChildCountClick = _props.handleNodeChildCountClick;
      var handleNodeCollapseClick = _props.handleNodeCollapseClick;
      var handleNodeLabelClick = _props.handleNodeLabelClick;
      var handleNodeLabelDoubleClick = _props.handleNodeLabelDoubleClick;
      var nodeId = _props.nodeId;
      var collapsed = _props.collapsed;
      var current = _props.current;
      var text = _props.text;
      var loaded = _props.loaded;
      var loading = _props.loading;
      var renderOptions = _props.renderOptions;


      var className = current ? 'list-group-item ' + styles["label"] + ' ' + styles["label-current"] : 'list-group-item ' + styles["label"];

      var textNode = hasChildren ? _react2.default.createElement(
        'span',
        { style: !renderOptions.multiSelect ? { paddingLeft: '8px' } : null },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      ) : //Must fix paddingLeft in styles.
      _react2.default.createElement(
        'span',
        { style: !renderOptions.multiSelect ? { paddingLeft: '8px' } : null },
        text
      );

      var childCountNode = hasChildren && renderOptions.showChildCount ? _react2.default.createElement(
        'div',
        { className: '' + styles["child-count-outer"],
          onClick: function onClick(e) {
            e.stopPropagation();handleNodeChildCountClick(nodeId, loaded);
          },
          onDoubleClick: function onDoubleClick(e) {
            e.stopPropagation();
          } },
        _react2.default.createElement(
          'span',
          { className: 'badge ' + styles["child-count"] },
          childCount
        )
      ) : null;

      var checkedIconNode = checked ? _react2.default.createElement('i', { className: 'glyphicon glyphicon-ok ' + styles['multi-select-checked-icon'] }) : null;

      var multiSelectCheckboxNode = renderOptions.multiSelect ? _react2.default.createElement(
        'div',
        { className: styles['multi-select-outer'],
          onClick: function onClick(e) {
            e.stopPropagation();handleNodeCheckBoxClick(nodeId);
          },
          onDoubleClick: function onDoubleClick(e) {
            e.stopPropagation();
          } },
        _react2.default.createElement(
          'div',
          { className: styles['multi-select'] },
          checkedIconNode
        )
      ) : null;
      var collapseNode = null;

      if (hasChildren) {
        var collapseIconClassName = collapsed ? 'glyphicon glyphicon-triangle-right' : 'glyphicon glyphicon-triangle-bottom';
        collapseNode = _react2.default.createElement(
          'div',
          { className: '' + styles['collapse-outer'],
            onClick: function onClick(e) {
              e.stopPropagation();handleNodeCollapseClick(nodeId, loaded);
            },
            onDoubleClick: function onDoubleClick(e) {
              e.stopPropagation();
            } },
          _react2.default.createElement('i', { className: collapseIconClassName + ' ' + styles['collapse-icon'] })
        );
      }

      return _react2.default.createElement(
        'li',
        { nodeId: nodeId, className: className,
          onClick: function onClick(e) {
            handleNodeLabelClick(nodeId);
          },
          onDoubleClick: function onDoubleClick(e) {
            e.stopPropagation();
            if (hasChildren) {
              handleNodeLabelDoubleClick(nodeId, loaded);
            }
          } },
        collapseNode,
        multiSelectCheckboxNode,
        textNode,
        childCountNode
      );
    }
  }]);

  return TreeViewLabel;
}(_react.Component);

TreeViewLabel.propTypes = {
  childCount: _react.PropTypes.number.isRequired,
  checked: _react.PropTypes.bool.isRequired,
  collapsed: _react.PropTypes.bool.isRequired,
  handleNodeCheckBoxClick: _react.PropTypes.func.isRequired,
  handleNodeChildCountClick: _react.PropTypes.func.isRequired,
  handleNodeCollapseClick: _react.PropTypes.func.isRequired,
  hasChildren: _react.PropTypes.bool.isRequired,
  nodeId: _react.PropTypes.string.isRequired,
  current: _react.PropTypes.bool.isRequired,
  renderOptions: _react.PropTypes.object.isRequired,
  text: _react.PropTypes.string.isRequired

};
exports.default = TreeViewLabel;