'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TreeViewLabel = require('./../components/TreeViewLabel');

var _TreeViewLabel2 = _interopRequireDefault(_TreeViewLabel);

var _Row = require('react-bootstrap/lib/Row');

var _Row2 = _interopRequireDefault(_Row);

var _treeView = require('../ducks/tree-view');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeView = function (_Component) {
  _inherits(TreeView, _Component);

  function TreeView() {
    _classCallCheck(this, TreeView);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(TreeView).apply(this, arguments));
  }

  _createClass(TreeView, [{
    key: 'render',
    value: function render() {
      var styles = require('./../styles/TreeView.scss');
      var _props = this.props;
      var nodes = _props.nodes;
      var handlers = _props.handlers;
      var renderOptions = _props.renderOptions;

      var componentListClassName = this.props.componentListClassName ? ' ' + this.props.componentListClassName : '';
      var componentContainerClassName = this.props.componentContainerClassName ? ' ' + this.props.componentContainerClassName : '';

      var renderNode = function renderNode(node, index, parentIndex) {
        var hasChildren = node['children'] !== undefined;
        var childCount = hasChildren ? node.children.length : 0;
        var checked = node.checked;
        var collapsed = node.collapsed !== undefined ? node.collapsed : false;
        var current = node.current;
        var labelText = node.label;
        var loaded = node.loaded;
        var loading = node.loading;
        var nodeStateClassName = '';
        var nodeId = parentIndex !== undefined ? parentIndex + '.' + index : '' + index;

        var children = hasChildren && !collapsed ? _react2.default.createElement(
          'li',
          null,
          _react2.default.createElement(
            'ul',
            { className: 'list-group ' + styles["list-group"] },
            node.children.map(function (childNode, index) {
              return renderNode(childNode, index, nodeId);
            })
          )
        ) : null;

        return _react2.default.createElement(
          'li',
          { key: nodeId },
          _react2.default.createElement(
            'ul',
            { className: 'list-group ' + styles["list-group"] },
            _react2.default.createElement(_TreeViewLabel2.default, { nodeId: nodeId,
              childCount: childCount,
              checked: checked,
              collapsed: collapsed,
              current: current,
              hasChildren: hasChildren,
              handleNodeCheckBoxClick: _treeView.toggleChecked,
              handleNodeChildCountClick: _treeView.toggleCollapsed,
              handleNodeCollapseClick: _treeView.toggleCollapsed,
              handleNodeLabelClick: _treeView.setCurrentNode,
              handleNodeLabelDoubleClick: _treeView.toggleCollapsed,
              handleNodeLoad: _treeView.load,
              loaded: loaded,
              loading: loading,
              renderOptions: renderOptions,
              text: labelText
            }),
            children
          )
        );
      };

      return _react2.default.createElement(
        'ul',
        { className: '' + styles["tree-view-container"] + componentListClassName },
        nodes.map(function (node, index) {
          return renderNode(node, index);
        })
      );
    }
  }]);

  return TreeView;
}(_react.Component);

TreeView.propTypes = {
  nodes: _react.PropTypes.array.isRequired,
  renderOptions: _react.PropTypes.object,
  componentListClassName: _react.PropTypes.string,
  componentContainerClassName: _react.PropTypes.string
};
exports.default = TreeView;